package com.evasion.common.flex.factory;

/**
 * Interface for locating resources, e.g. JDBC datasources.
 */
public interface IResourceLocator
{
   /**
    * Locate the resource with the supplied name and type.
    * 
    * @param name the resource name.
    * @return the resource.
    * @throws ResourceException if there is an error locating the resource.
    */
   Object locate(
         String name ) throws ResourceException;
}
