/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.common.security.user;

import com.evasion.common.Component;
import com.evasion.common.Constante;
import com.evasion.common.Utils;
import com.evasion.common.security.SecurityConst;
import com.evasion.entity.security.User;
import java.io.IOException;
import javax.faces.component.FacesComponent;
import javax.faces.component.html.*;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 *
 * @author sebastien
 */
@FacesComponent(value = "com.evasion.common.security.user.LoginComponent")
public class LoginComponent extends Component {

    private static final String USER_NAME = "j_username";

    private static final String PWD_NAME = "j_password";

    private static final String FORM_ACTION = "j_security_check";

    private static final String BACKWARD_NAME = "j_backward";

    /**
     * LOGGER.
     */
    private static final Logger LOGGER = LoggerFactory.getLogger(
            LoginComponent.class);


    protected enum PropertyKeys {

        id,
        rendered,
        type,
        columns,
        inputSize,
        styleClass;

        String toString;

        PropertyKeys(String toString) {
            this.toString = toString;
        }

        PropertyKeys() {
        }

        @Override
        public String toString() {
            return ((toString != null) ? toString : super.toString());
        }
    }

    @Override
    public void encodeBegin(FacesContext context) throws IOException {
        ResponseWriter responseWriter = context.getResponseWriter();
        responseWriter.startElement(Constante.HTML_ELEMENT_DIV, null);
        responseWriter.startElement("form", null);
        responseWriter.writeAttribute(PropertyKeys.id.toString(), "SAMForm", null);
        responseWriter.writeAttribute("action", FORM_ACTION, null);
        responseWriter.writeAttribute("method", "post", null);

        // Zone de message 
        HtmlMessages messages = new HtmlMessages();
       // messages.setErrorClass();
        this.getChildren().add(messages);

        HtmlPanelGrid panel = new HtmlPanelGrid();
        panel.setColumns(2);
        // Champ nom d'utilisateur
        HtmlOutputLabel labelUser = new HtmlOutputLabel();
        labelUser.setFor(USER_NAME);
        labelUser.setValue(Utils.getMessageResourceString(SecurityConst.BUNDLE_NAME, SecurityConst.USER_LOGIN, null, null));
        //labelUser.s
        panel.getChildren().add(labelUser);

        HtmlInputText inputUser = new HtmlInputText();
        inputUser.setId(USER_NAME);
        inputUser.setMaxlength(User.USERNAME_MAX_LENGHT);
        inputUser.setSize(User.USERNAME_MAX_LENGHT);
        panel.getChildren().add(inputUser);
        
        // Champ password
        HtmlOutputLabel labelPwd = new HtmlOutputLabel();
        labelPwd.setFor(PWD_NAME);
        labelPwd.setValue(Utils.getMessageResourceString(SecurityConst.BUNDLE_NAME, SecurityConst.PWD_LOGIN, null, null));
        panel.getChildren().add(labelPwd);

        HtmlInputSecret inputPwd = new HtmlInputSecret();
        inputPwd.setId(PWD_NAME);
        inputPwd.setMaxlength(User.PASSWORD_MAX_LENGHT);
        inputPwd.setSize(User.PASSWORD_MAX_LENGHT);
        panel.getChildren().add(inputPwd);


        HtmlCommandButton button = new HtmlCommandButton();
        button.setId(FORM_ACTION);
        button.setValue(Utils.getMessageResourceString(SecurityConst.BUNDLE_NAME, SecurityConst.BUTTON_LOGIN, null, null));
        panel.getChildren().add(button);
        
        this.getChildren().add(panel);

    }

    @Override
    public void encodeChildren(FacesContext context) throws IOException {
    }

    @Override
    public void encodeEnd(FacesContext context) throws IOException {
        ResponseWriter responseWriter = context.getResponseWriter();


        responseWriter.endElement("form");
        responseWriter.endElement(Constante.HTML_ELEMENT_DIV);
    }

    public void setColumns(int columns) {
        getStateHelper().put(PropertyKeys.columns, columns);
        handleAttribute(PropertyKeys.columns.toString(), columns);
    }

    public int getColumns() {
        return (Integer) getStateHelper().eval(PropertyKeys.columns, 2);
    }


    public void setStyleClass(String styleClass) {
        getStateHelper().put(PropertyKeys.styleClass, styleClass);
        handleAttribute(PropertyKeys.styleClass.toString(), styleClass);
    }

    public String getStyleClass() {
        return (String) getStateHelper().eval(PropertyKeys.styleClass, "");
    }
    
}
